OpenMM

- Main Page
- Related Pages
- Classes

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
Public Member Functions | Protected Member Functions | List of all members
DrudeLangevinIntegrator Class Reference

This Integrator simulates systems that include Drude particles. More...

`#include <DrudeLangevinIntegrator.h>`

Inheritance diagram for DrudeLangevinIntegrator:

## Public Member Functions
| DrudeLangevinIntegrator (double temperature, double frictionCoeff, double drudeTemperature, double drudeFrictionCoeff, double stepSize)
| Create a DrudeLangevinIntegrator. More...
double | getTemperature () const
| Get the temperature of the main heat bath (in Kelvin). More...
void | setTemperature (double temp)
| Set the temperature of the main heat bath (in Kelvin). More...
double | getFriction () const
| Get the friction coefficient which determines how strongly the system is coupled to the main heat bath (in inverse ps). More...
void | setFriction (double coeff)
| Set the friction coefficient which determines how strongly the system is coupled to the main heat bath (in inverse ps). More...
double | getDrudeTemperature () const
| Get the temperature of the heat bath applied to internal coordinates of Drude particles (in Kelvin). More...
void | setDrudeTemperature (double temp)
| Set the temperature of the heat bath applied to internal coordinates of Drude particles (in Kelvin). More...
double | getDrudeFriction () const
| Get the friction coefficient which determines how strongly the internal coordinates of Drude particles are coupled to the heat bath (in inverse ps). More...
void | setDrudeFriction (double coeff)
| Set the friction coefficient which determines how strongly the internal coordinates of Drude particles are coupled to the heat bath (in inverse ps). More...
int | getRandomNumberSeed () const
| Get the random number seed. More...
void | setRandomNumberSeed (int seed)
| Set the random number seed. More...
void | step (int steps)
| Advance a simulation through time by taking a series of time steps. More...
Public Member Functions inherited from Integrator
| Integrator ()
virtual | ~Integrator ()
double | getStepSize () const
| Get the size of each time step, in picoseconds. More...
void | setStepSize (double size)
| Set the size of each time step, in picoseconds. More...
double | getConstraintTolerance () const
| Get the distance tolerance within which constraints are maintained, as a fraction of the constrained distance. More...
void | setConstraintTolerance (double tol)
| Set the distance tolerance within which constraints are maintained, as a fraction of the constrained distance. More...

## Protected Member Functions
void | initialize (ContextImpl &context)
| This will be called by the Context when it is created. More...
void | cleanup ()
| This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup. More...
void | stateChanged (State::DataType changed)
| When the user modifies the state, we need to mark that the forces need to be recalculated. More...
std::vector< std::string > | getKernelNames ()
| Get the names of all Kernels used by this Integrator. More...
double | computeKineticEnergy ()
| Compute the kinetic energy of the system at the current time. More...

## Additional Inherited Members
Protected Attributes inherited from Integrator
ContextImpl * | context
Context * | owner

## Detailed Description

This Integrator simulates systems that include Drude particles.

It applies two different Langevin thermostats to different parts of the system. The first is applied to ordinary particles (ones that are not part of a Drude particle pair), as well as to the center of mass of each Drude particle pair. A second thermostat, typically with a much lower temperature, is applied to the relative internal displacement of each pair.

This Integrator requires the System to include a DrudeForce, which it uses to identify the Drude particles.

## Constructor & Destructor Documentation

DrudeLangevinIntegrator | ( | double | temperature,
|  | double | frictionCoeff,
|  | double | drudeTemperature,
|  | double | drudeFrictionCoeff,
|  | double | stepSize
| ) |  |

Create a DrudeLangevinIntegrator.

Parameters

  temperature | the temperature of the main heat bath (in Kelvin)
  frictionCoeff | the friction coefficient which couples the system to the main heat bath (in inverse picoseconds)
  drudeTemperature | the temperature of the heat bath applied to internal coordinates of Drude particles (in Kelvin)
  drudeFrictionCoeff | the friction coefficient which couples the system to the heat bath applied to internal coordinates of Drude particles (in inverse picoseconds)
  stepSize | the step size with which to integrator the system (in picoseconds)

## Member Function Documentation

void cleanup | ( |  | ) |
| protected virtual

This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup.

It will also get called again if the application calls reinitialize() on the Context.

Reimplemented from Integrator.

double computeKineticEnergy | ( |  | ) |
| protected virtual

Compute the kinetic energy of the system at the current time.

Implements Integrator.

double getDrudeFriction | ( |  | ) | const
| inline

Get the friction coefficient which determines how strongly the internal coordinates of Drude particles are coupled to the heat bath (in inverse ps).

Returns
  the friction coefficient, measured in 1/ps

double getDrudeTemperature | ( |  | ) | const
| inline

Get the temperature of the heat bath applied to internal coordinates of Drude particles (in Kelvin).

Returns
  the temperature of the heat bath, measured in Kelvin

double getFriction | ( |  | ) | const
| inline

Get the friction coefficient which determines how strongly the system is coupled to the main heat bath (in inverse ps).

Returns
  the friction coefficient, measured in 1/ps

std::vector<std::string> getKernelNames | ( |  | ) |
| protected virtual

Get the names of all Kernels used by this Integrator.

Implements Integrator.

int getRandomNumberSeed | ( |  | ) | const
| inline

Get the random number seed.

See setRandomNumberSeed() for details.

double getTemperature | ( |  | ) | const
| inline

Get the temperature of the main heat bath (in Kelvin).

Returns
  the temperature of the heat bath, measured in Kelvin

void initialize | ( | ContextImpl & | context | ) |
| protected virtual

This will be called by the Context when it is created.

It informs the Integrator of what context it will be integrating, and gives it a chance to do any necessary initialization. It will also get called again if the application calls reinitialize() on the Context.

Implements Integrator.

void setDrudeFriction | ( | double | coeff | ) |
| inline

Set the friction coefficient which determines how strongly the internal coordinates of Drude particles are coupled to the heat bath (in inverse ps).

Parameters

  coeff | the friction coefficient, measured in 1/ps

void setDrudeTemperature | ( | double | temp | ) |
| inline

Set the temperature of the heat bath applied to internal coordinates of Drude particles (in Kelvin).

Parameters

  temp | the temperature of the heat bath, measured in Kelvin

void setFriction | ( | double | coeff | ) |
| inline

Set the friction coefficient which determines how strongly the system is coupled to the main heat bath (in inverse ps).

Parameters

  coeff | the friction coefficient, measured in 1/ps

void setRandomNumberSeed | ( | int | seed | ) |
| inline

Set the random number seed.

The precise meaning of this parameter is undefined, and is left up to each Platform to interpret in an appropriate way. It is guaranteed that if two simulations are run with different random number seeds, the sequence of random forces will be different. On the other hand, no guarantees are made about the behavior of simulations that use the same seed. In particular, Platforms are permitted to use non-deterministic algorithms which produce different results on successive runs, even if those runs were initialized identically.

If seed is set to 0 (which is the default value assigned), a unique seed is chosen when a Context is created from this Force. This is done to ensure that each Context receives unique random seeds without you needing to set them explicitly.

void setTemperature | ( | double | temp | ) |
| inline

Set the temperature of the main heat bath (in Kelvin).

Parameters

  temp | the temperature of the heat bath, measured in Kelvin

void stateChanged | ( | State::DataType | changed | ) |
| protected virtual

When the user modifies the state, we need to mark that the forces need to be recalculated.

Reimplemented from Integrator.

void step | ( | int | steps | ) |
| virtual

Advance a simulation through time by taking a series of time steps.

Parameters

  steps | the number of time steps to take

Implements Integrator.

The documentation for this class was generated from the following file:

- DrudeLangevinIntegrator.h